/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

// LAPACK+BLAS definitions are here
// Define to a macro mangling the given C identifier (in lower and upper
//   case), which must not contain underscores, for linking with Fortran.

#define F77_RET_I int
#define F77_RET_D double
#define F77_RET_Z complex<double>

//Level 1 BLAS
#define dasum_f77  F77_FUNC (dasum,  DASUM)
#define daxpy_f77  F77_FUNC (daxpy,  DAXPY)
#define dcopy_f77  F77_FUNC (dcopy,  DCOPY)
#define ddot_f77   F77_FUNC (ddot,   DDOT)

#define dcabs1_f77 F77_FUNC (dcabs1, DCABS1)
#define dzasum_f77 F77_FUNC (dzasum, DZASUM)

#define zaxpy_f77  F77_FUNC (zaxpy,  ZAXPY)
#define zcopy_f77  F77_FUNC (zcopy,  ZCOPY)
#define zdotc_f77  F77_FUNC (zdotc,  ZDOTC)
#define zdotu_f77  F77_FUNC (zdotu,  ZDOTU)
#define zdrot_f77  F77_FUNC (zdrot,  ZDROT)

#define idamax_f77 F77_FUNC (idamax, IDAMAX)
#define izamax_f77 F77_FUNC (izamax, IZAMAX)

//Level 2 BLAS
#define zgemv_f77  F77_FUNC (zgemv,  ZGEMV)
#define zgbmv_f77  F77_FUNC (zgbmv,  ZGBMV)
#define zgerc_f77  F77_FUNC (zgerc,  ZGERC)
#define zgeru_f77  F77_FUNC (zgeru,  ZGERU)
#define zher_f77   F77_FUNC (zher,   ZHER)
#define zhbmv_f77  F77_FUNC (zhbmv,  ZHBMV)
#define zhemv_f77  F77_FUNC (zhemv,  ZHEMV)

//Level 3 BLAS

#define zgemm_f77  F77_FUNC (zgemm,  ZGEMM)
#define zhemm_f77  F77_FUNC (zhemm,  ZHEMM)

//not yet
#define dgbmv_f77  F77_FUNC (dgbmv,  DGBMV)
#define ztrsv_f77  F77_FUNC (ztrsv,  ZTRSB)
#define zscal_f77  F77_FUNC (zscal,  ZSCAL)
#define dznrm2_f77 F77_FUNC (dznrm2, DZNRM2)
#define zrotg_f77  F77_FUNC (zrotg,  ZROTG)
#define zdscal_f77 F77_FUNC (zdscal, ZDSCAL)
#define zhpr_f77   F77_FUNC (zhpr,   ZHPR)
#define zhpr2_f77  F77_FUNC (zhpr2,  ZHPR2)
#define zswap_f77  F77_FUNC (zswap,  ZSWAP)
#define zhpmv_f77  F77_FUNC (zhpmv,  ZHPMV)
#define zher2_f77  F77_FUNC (zher2,  ZHER2)
#define zherk_f77  F77_FUNC (zherk,  ZHERK)
#define zher2k_f77 F77_FUNC (zher2k, ZHER2K)
#define zsymm_f77  F77_FUNC (zsymm,  ZSYMM)
#define zsyr2k_f77 F77_FUNC (zsyr2k, ZSYR2K)
#define zsyrk_f77  F77_FUNC (zsyrk,  ZSYRK)
#define ztbmv_f77  F77_FUNC (ztbmv,  ZTBMV)
#define ztrsm_f77  F77_FUNC (ztrsm,  ZTRSM)
#define ztrmm_f77  F77_FUNC (ztrmm,  ZTRMM)
#define ztrmv_f77  F77_FUNC (ztrmv,  ZTRMV)
#define ztbsv_f77  F77_FUNC (ztbsv,  ZTBSV)
#define ztpmv_f77  F77_FUNC (ztpmv,  ZTPMV)
#define ztpsv_f77  F77_FUNC (ztpsv,  ZTPSV)
#define dger_f77   F77_FUNC (dger,   DGER)
#define dnrm2_f77  F77_FUNC (dnrm2,  DNRM2)
#define dsbmv_f77  F77_FUNC (dsbmv,  DSBMV)
#define drot_f77   F77_FUNC (drot,   DROT)
#define dtrsm_f77  F77_FUNC (dtrsm,  DTRSM)
#define dgemm_f77  F77_FUNC (dgemm,  DGEMM)
#define dgemv_f77  F77_FUNC (dgemv,  DGEMV)
#define dscal_f77  F77_FUNC (dscal,  DSCAL)
#define dspmv_f77  F77_FUNC (dspmv,  DSPMV)
#define dspr_f77   F77_FUNC (dspr,   DSPR)
#define dspr2_f77  F77_FUNC (dspr2,  DSPR2)
#define dsymm_f77  F77_FUNC (dsymm,  DSYMM)
#define dsymv_f77  F77_FUNC (dsymv,  DSYMV)
#define dsyr_f77   F77_FUNC (dsyr,   DSYR)
#define dsyr2_f77  F77_FUNC (dsyr2,  DSYR2)
#define dswap_f77  F77_FUNC (dswap,  DSWAP)
#define dsyr2k_f77 F77_FUNC (dsyr2k, DSYR2K)
#define dsyrk_f77  F77_FUNC (dsyrk,  DSYRK)
#define dtbmv_f77  F77_FUNC (dtbmv,  DTBMV)
#define dtbsv_f77  F77_FUNC (dtbsv,  DTBSV)
#define dtpmv_f77  F77_FUNC (dtpmv,  DTPMV)
#define dtpsv_f77  F77_FUNC (dtpsv,  DTPSV)
#define dtrmm_f77  F77_FUNC (dtrmm,  DTRMM)
#define dtrmv_f77  F77_FUNC (dtrmv,  DTRMV)
#define dtrsm_f77  F77_FUNC (dtrsm,  DTRSM)
#define dtrsv_f77  F77_FUNC (dtrsv,  DTRSV)
#define drotg_f77  F77_FUNC (drotg,  DROTG)
#define drotm_f77  F77_FUNC (drotm,  DROTM)

extern "C"
{
// BLAS
  F77_RET_I drotm_f77(int* n, double* dx, int *incx, double* dy, int *incy, double* dparam);

  F77_RET_I drotg_f77(double* a, double* b, double* c, double* s);

  F77_RET_I dtrsv_f77(const char* uplo, const char* trans, const char* diag, int* n,       double* A, int* lda,
       double* X, int* incx);
  
  F77_RET_I dtrsm_f77(const char* side, const char* uplo, const char* trans, const char* diag,
       int* M, int* n,  double* alpha, double* A, int* lda,
       double* B, int* ldb);

  F77_RET_I dtrmv_f77(const char* uplo, const char *trans, const char* diag, int *n,
       double *A, int *lda,
       double *x, int *incx);

  F77_RET_I dtrmm_f77(const char* side, const char* uplo, const char* trans, const char* diag, 
       int* M, int* n, double* alpha, double* A, int* lda, double* B, int* ldb);

  F77_RET_I dtpmv_f77 (const char* uplo, const char* trans, const char* diag, int* n, 
       double* Ap, double* X, int* incx);

  F77_RET_I dtpsv_f77 (const char* uplo, const char* trans, const char* diag, int* n, 
       double* Ap, double* X, int* incx);

  F77_RET_I dtbsv_f77(const char* uplo, const char* trans, const char* diag, int* n, int* K,
       double* A, int* lda, 
       double* X, int* incx);

  F77_RET_I dtbmv_f77(const char* uplo, const char* trans, const char* diag, int* n, int* K,
       double* A, int* lda, double* X, int* incx);

  F77_RET_I dsyr2k_f77(const char* uplo, const char* trans, int* n, int* K,
        double* alpha, double* A, int* lda, double* B, int* ldb,
        double* beta, double* C, int* ldc);

  F77_RET_I dsyrk_f77(const char* uplo, const char* trans, int* n, int* K,
       double* alpha, double* A, int* lda, double* beta, double* C, int* ldc);

  F77_RET_I dsymm_f77(const char* side, const char* uplo, int* M, int* n,
       double* alpha, double* A, int* lda, double* B, int* ldb,
       double* beta, double* C, int* ldc);

  F77_RET_I dsymv_f77 (const char* uplo, int* n, double* alpha,  double* A, int* lda,
       double* X, int* incx,  double* beta,  double* Y, int* incY);

  F77_RET_I dsyr_(const char* uplo, int* n, double* alpha, double* X, int* incx,
		  double* A, int* lda);

  F77_RET_I dsyr2_(const char* uplo, int* n, double* alpha, double* X, int* incx,
       double* Y, int* incY, double* A, int* lda);

  F77_RET_I dswap_f77(int* n, double* X, int* incx, double* Y, int* incY);

  F77_RET_I dspr_f77(const char* uplo, int* n, double* alpha,
      double* X, int* incx, double* Ap);

  F77_RET_I dspr2_f77(const char* uplo, int* n, double* alpha, 
       double* X, int* incx, double* Y, int* incY, double* A);

  F77_RET_I dspmv_f77(const char* uplo, int* n, double* alpha,
       double* Ap, double* X, int* incx,  double* beta,
       double* Y, int* incY);

  F77_RET_I dscal_f77(int* n, double* alpha, double* X, int* incx);

  F77_RET_I dgemv_f77(const char* trans, int* M, int* n, double* alpha,
       double* A, int* lda, double* X, int* incx, double* beta,
       double* Y, int* incY);

  F77_RET_I dgemm_f77(const char* transA, const char* transB, int* M, int* n, int* K,
       double* alpha, double* A, int* lda, double* B, int* ldb,
       double* beta, double* C, int* ldc);

  F77_RET_I drot_f77(int* n, double* X, int* incx,
      double* Y, int* incY, double* c, double* s);

  F77_RET_I dsbmv_f77(const char* uplo, int* n, int* K,
       double* alpha, double* A, int* lda, double* X, int* incx,
       double* beta, double* Y, int* incY);

  F77_RET_D dnrm2_f77(int* n, double* x, int* incx);

  F77_RET_I dger_f77(int* m, int* n, double* alpha, double* X, int* incx,
      double* y, int* incy, double* A, int* lda);

  F77_RET_I ztpsv_f77(const char* uplo, const char* trans, const char* diag, int* n, 
       complex<double>* AP, complex<double>* x, int* incx);

  F77_RET_I ztpmv_f77(const char* uplo, const char* trans, const char* diag, int* n, 
       complex<double>* AP, complex<double>* x, int* incx);

  F77_RET_I ztbsv_f77(const char* uplo, const char* trans, const char* diag, int* n, int* K,
       complex<double>* A, int* lda, complex<double>* x, int* incx);

  F77_RET_I ztrmv_f77(const char* uplo, const char *trans, const char* diag, int *N,  
       complex<double> *A, int *lda, complex<double> *x, int *incx);

  F77_RET_I ztrmm_f77(const char* side, const char* uplo, const char* trans, const char* diag, 
       int* m, int* n, complex<double>* alpha, complex<double>* A, int* lda,
       complex<double>* B, int* ldb);

  F77_RET_I ztrsm_f77(const char* side, const char* uplo, const char* trans, const char* diag,
       int* m, int* n, complex<double>* alpha, complex<double>* A, int* lda,
       complex<double>* B, int* ldb);

  F77_RET_I ztbmv_f77(const char* uplo, const char* trans, const char* diag,
      int* n, int* k, complex<double>* A, int* lda, complex<double>* X, int* incx);

  F77_RET_I zsyrk_f77(const char* uplo, const char* trans, int* n, int* K,
       complex<double>* alpha, complex<double>* A, int* lda,
       complex<double>* beta, complex<double>* C, int* ldc);

  F77_RET_I zsyr2k_f77(const char* uplo, const char* trans, int* n, int* K,
        complex<double>* alpha, complex<double>* A, int* lda,
        complex<double>* B, int* ldb, complex<double>* beta,
        complex<double>* C, int* ldc);

  F77_RET_I zsymm_f77(const char* side, const char* uplo, int* m, int* n,
       complex<double>* alpha, complex<double>* A, int* lda,
       complex<double>* B, int* ldb, complex<double>* beta,
       complex<double>* C, int* ldc);
  
  F77_RET_I zher2k_f77(const char* uplo, const char* trans, int* n, int* k,
        complex<double>* alpha, complex<double>* A, int* lda,
        complex<double>* B, int* ldb, double* beta, complex<double>* C, int* ldc);

  F77_RET_I zherk_f77(const char* uplo, const char* trans, int* n, int* k,
       double* alpha, complex<double>* A, int* lda,
       double* beta,  complex<double>* C, int* ldc);

  F77_RET_I zhemv_f77(const char* uplo, int* n, complex<double>* alpha,
       complex<double>* A, int* lda,  complex<double>* x, int* incy,
       complex<double>* beta, complex<double>* y, int* incy);

  F77_RET_I zher2_f77(const char* uplo, int* n, complex<double>* alpha,
       complex<double>* X, int* incx, complex<double>* Y, int* incY,
       complex<double>* A, int* lda);

  F77_RET_I zher_f77(const char* uplo, int* n,
      double* alpha, complex<double>* X, int* incx,
      complex<double>* A, int* lda);

  F77_RET_I zhpmv_f77(const char* uplo, int* n,  complex<double>* alpha,
       complex<double>* AP, complex<double>* x, int* incy,
       complex<double>* beta, complex<double>* y, int* incy);

  F77_RET_I zswap_f77(int* n, complex<double>* X, int* incx,
       complex<double>* Y, int* incY);

  F77_RET_I zhpr2_f77(const char* uplo, int* n, complex<double>* alpha,
       complex<double>* X, int* incx, complex<double>* Y, int* incy,
       complex<double>* Ap);

  F77_RET_I zhpr_f77(const char* uplo, int* n, double* alpha,
      complex<double>* X, int* inc, complex<double>* Ap);

  F77_RET_I zdscal_f77(int* n, double* alpha, complex<double>* X, int* incx);

  F77_RET_I zdrot_f77(int *n, complex<double>* cx, int *incx, complex<double>* cy, 
        int *incy, double *c, double *s);

  F77_RET_I zhbmv_f77(const char* uplo, int* n, int* K, complex<double>* alpha,
       complex<double>* A, int* lda, complex<double>* X, int* incx,
       complex<double>* beta, complex<double>* Y, int* incY);

  F77_RET_I zrotg_f77(complex<double>* a, complex<double>* b, double* c, complex<double>* s);

  F77_RET_D dznrm2_f77 (int* n, complex<double>* X, int* incx);

  F77_RET_I zscal_f77 (int* n, complex<double>* alpha,
       complex<double>* X, int* incx);

  F77_RET_D dzasum_f77(int* n, complex<double>* X, int* incx);

  F77_RET_I ztrsv_f77(const char* uplo, const char* trans, const char* diag, int* n,
       complex<double>* A, int* lda,
       complex<double>* X, int* incx);

  F77_RET_I zhemm_f77 (const char* side, const char* uplo, int* M, int* n,
       complex<double>* alpha,
       complex<double>* A, int* lda,
       complex<double>* B, int* ldb,
       complex<double>* beta,
       complex<double>* C, int* ldc);

  F77_RET_I izamax_f77 (int* n,
        complex<double>* X, int* incx);

  F77_RET_I zgerc_f77 (int* M, int* n,
       complex<double>* alpha,
       complex<double>* X, int* incx,
       complex<double>* Y, int* incY,
       complex<double>* A, int* lda);

  F77_RET_I zgeru_f77(int* M, int* n,
       complex<double>* alpha,
       complex<double>* X, int* incx,
       complex<double>* Y, int* incY,
       complex<double>* A, int* lda);

  F77_RET_I zgemm_f77 (const char* transA, const char* transB, int* M, int* n, int* K,
       complex<double>* alpha,
       complex<double>* A, int* lda,
       complex<double>* B, int* ldb,
       complex<double>* beta,
       complex<double>* C, int* ldc);

  F77_RET_I zgemv_f77 (const char* trans, int* M, int* n,
       complex<double>* alpha,
       complex<double>* A, int* lda,
       complex<double>* X, int* incx,
       complex<double>* beta,
       complex<double>* Y, int* incY);

  F77_RET_I zgbmv_f77 (const char *trans, int *M, int *N, int *KL, int *KU, 
       complex<double> *alpha, 
       complex<double> *A, int *lda, 
       complex<double> *X, int *incx, 
       complex<double> *beta, 
       complex<double> *Y, int *incY);

  F77_RET_Z zdotu_f77 (int* n, complex<double>* X, int* incx, 
     complex<double>* Y, int* incY);

  F77_RET_Z zdotc_f77 (int* n, complex<double>* X, int* incx, 
     complex<double>* Y, int* incY);

  F77_RET_I zcopy_f77 (int* n,
       complex<double>* X, int* incx,
       complex<double>* Y, int* incY);

  F77_RET_I zaxpy_f77 (int* n,
       complex<double>* alpha,
       complex<double>* X, int* incx,
       complex<double>* Y, int* incY);

  F77_RET_I  dcopy_f77 (int* n,
       double* X, int* incx,
       double* Y, int* incY);
  F77_RET_D ddot_f77 (int* n, 
     double* X, int* incx, 
     double* Y, int* incY);
  F77_RET_D dasum_f77 (int* n,  double* X, int* incx);

  F77_RET_D dcabs1_f77 (complex<double> *Z);

  F77_RET_I daxpy_f77  (int* n,  double* alpha,
     double* X, int* incx,
     double* Y, int* incY);
  F77_RET_I idamax_f77 (int* n, double* X, int* incx);
  
  F77_RET_I dgbmv_f77 (const char *trans, int *M, int *N, int *KL, int *KU, 
       double *alpha, 
       double *A, int *lda, 
       double *x, int *incx, 
       double *beta, 
       double *Y, int *incY);
// LAPACK
}
